/*
 *  TOPPERS ECHONET Lite Communication Middleware
 * 
 *  Copyright (C) 2014 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: echonet.h 107 2015-06-10 11:40:31Z coas-nagasima $
 */

#ifndef ECHONET_H
#define ECHONET_H

#include <t_stddef.h>
#include <t_syslog.h>

#include "echonet_rename.h"
#include "echonet_class.h"
#include "echonet_app_config.h"

#ifdef __cplusplus
extern "C" {
#endif

#define E_BRK		(-100)

#define EOBJ_NULL 0x00
#define EOBJ_LOCAL_NODE 0x01			/* m[h */
#define EOBJ_SYNC_REMOTE_NODE 0x02		/* m[h */
#define EOBJ_ASYNC_REMOTE_NODE 0x04		/* m[hi񓯊j */
#define EOBJ_DEVICE 0x08				/* @IuWFNg */

#define EPC_NONE 0x00
#define EPC_RULE_SET 0x01				/* ANZX[ Set */
#define EPC_RULE_GET 0x02				/* ANZX[ Get */
#define EPC_RULE_ANNO 0x04				/* ANZX[ Anno */
#define EPC_ANNOUNCE 0x40				/* ԕωʒm */
#define EPC_VARIABLE 0x80				/* ϒf[^ */

typedef enum _echonet_enod_id
{
	ENOD_NOT_MATCH_ID	= -1,
	ENOD_MULTICAST_ID	= 0,			/* }`LXgAhXID */
	ENOD_LOCAL_ID		= 1,			/* m[hAhXID */
	ENOD_API_ID			= 2,			/* APIAhXID */
	ENOD_REMOTE_ID		= 3,			/* m[hAhXID */
} ECN_ENOD_ID;

/* ECHONET LiteKi */
typedef enum
{
	ECN_EDH1_ECHONET_LITE	=	0x10
} ECN_EHD1_ECL_VERSION;

/* d`1/2 */
typedef enum
{
	ECN_EDH2_FORMAT_1 = 0x81,	/* d`1 */
	ECN_EDH2_FORMAT_2 = 0x82	/* d`2 */
} ECN_EHD2_FORMAT;

/* ECHONET LiteT[rXR[h */
typedef enum _echonet_service_code
{
	ESV_NOP				=	0,		/* (@\wȂ)							*/
	ESV_SET_I			=	0x60,	/* vpeBlݗvisvj		*/
	ESV_SET_C			=	0x61,	/* vpeBlݗvivj		*/
	ESV_GET				=	0x62,	/* vpeBlǂݏov					*/
	ESV_INF_REQ			=	0x63,	/* vpeBlʒmv						*/
	ESV_SET_GET			=	0x6E,	/* vpeBl݁Eǂݏov		*/
	ESV_SET_RES			=	0x71,	/* vpeBl݉					*/
	ESV_GET_RES			=	0x72,	/* vpeBlǂݏo					*/
	ESV_INF				=	0x73,	/* vpeBlʒm							*/
	ESV_INFC			=	0x74,	/* vpeBlʒmivj				*/
	ESV_INFC_RES		=	0x7A,	/* vpeBlʒm						*/
	ESV_SET_GET_RES		=	0x7E,	/* vpeBl݁Eǂݏo		*/
	ESV_SET_I_SNA		=	0x50,	/* vpeBlݗvs			*/
	ESV_SET_C_SNA		=	0x51,	/* vpeBlݗvs			*/
	ESV_GET_SNA			=	0x52,	/* vpeBlǂݏos				*/
	ESV_INF_SNA			=	0x53,	/* vpeBlʒms					*/
	ESV_SET_GET_SNA		=	0x5E	/* vpeBl݁Eǂݏos	*/
} ECN_SRV_CODE;

#ifdef __CA850__
#pragma pack(1)
#elif __RX
#pragma pack
#elif _MSC_VER
#pragma pack(push, 1)
#endif

/*
 *  ECHONET Litedwb_[
 */
typedef struct
{
	uint8_t	ehd1;		/* ECHONET Litedwb_[1 ECN_EHD1_ECL_VERSION */
	uint8_t	ehd2;		/* ECHONET Litedwb_[2 ECN_EHD2_FORMAT */
	uint16_t	tid;	/* gUNVID */
} T_ECN_HDR;

/*
 *  ECHONET LiteIuWFNgR[h
 */
typedef struct
{
	uint8_t	eojx1;		/* NXO[vR[h */
	uint8_t	eojx2;		/* NXR[h */
	uint8_t	eojx3;		/* CX^XR[h */
} T_ECN_EOJ;

/*
 *  ECHONET Litef[^wb_[
 */
typedef struct
{
	T_ECN_EOJ	seoj;	/* MECHONET LiteIuWFNgw */
	T_ECN_EOJ	deoj;	/* ECHONET LiteIuWFNgw */
	uint8_t	esv;		/* ECHONET LiteT[rX (ECN_SRV_CODE) */
	uint8_t	opc;		/* vpeB */
} T_ECN_EDATA_BODY;

/*
 *  ECHONET LitevpeB
 */
typedef struct
{
	uint8_t	epc;		/* ECHONET LitevpeBR[h */
	uint8_t	pdc;		/* EDT̃oCg */
	/*void	*p_edt;*/	/* vpeBlf[^ */
} T_ECN_PRP;

/*
 *  ECHONET Litef[^
 */
typedef struct
{
	T_ECN_HDR			ecn_hdr;
	T_ECN_EDATA_BODY	edata;
	T_ECN_PRP			ecn_prp;
} T_ECN_EDT_HDR;

/*
 *  ECHONET Lite d
 */
typedef struct echonet_object_data
{
	uint8_t _private1[192];
	T_ECN_EDT_HDR hdr;
	uint8_t _private2[64 - sizeof(T_ECN_EDT_HDR)];
} T_EDATA;

#ifdef __CA850__
#pragma pack(8)
#elif __RX
#pragma unpack
#elif _MSC_VER
#pragma pack(pop)
#endif

/*
 *  d̓Ce[^[
 */
typedef struct echonet_epc_enumerator
{
	T_EDATA *pk_esv;
	uint8_t count;			/* ǂݎ蒆̃ubNɂvpeB */
	uint8_t got_ct;			/* ǂݎ蒆̃ubNŁAǂݎ */
	uint8_t next_blk_ct;	/* 㑱ubN */
	uint8_t is_eof;			/* I[ɒBA0 */
	int cur;
} T_ENUM_EPC;

typedef struct echonet_property_initialization_block EPRPINIB;

/*
 * ECHONET Lite vpeB̐ݒ֐
 */
typedef int (EPRP_SETTER)(const EPRPINIB *item, const void *src, int size, bool_t *anno);

/*
 * ECHONET Lite vpeB̎擾֐
 */
typedef int (EPRP_GETTER)(const EPRPINIB *item, void *dst, int size);

/*
 *  ECHONET Lite vpeBubN
 */
struct echonet_property_initialization_block
{
	uint8_t		eprpcd;			/* ECHONET Lite vpeBR[h */
	ATR			eprpatr;		/* ECHONET Lite vpeB */
	uint8_t		eprpsz;			/* ECHONET Lite vpeB̃TCY */
	intptr_t	exinf;			/* ECHONET Lite vpeB̊g */
	EPRP_SETTER	*eprpset;		/* ECHONET Lite vpeB̐ݒ֐ */
	EPRP_GETTER	*eprpget;		/* ECHONET Lite vpeB̎擾֐ */
};

#define TMIN_EOBJID		1		/* ECHONET Lite IuWFNgID̍ŏl */

/*
 *  ECHONET Lite IuWFNgubN
 */
typedef struct echonet_object_initialization_block
{
	ATR			eobjatr;		/* ECHONET Lite IuWFNg */
	ID			enodid;			/* ECHONET Lite m[hvt@CIuWFNgID */
	intptr_t	exinf;			/* ECHONET Lite IuWFNg̊g */
	uint8_t		eojx1;			/* ECHONET Lite IuWFNg̃NXO[vR[h */
	uint8_t		eojx2;			/* ECHONET Lite IuWFNg̃NXR[h */
	uint8_t		eojx3;			/* ECHONET Lite IuWFNg̃CX^XR[h */
	const EPRPINIB *eprp;		/* ECHONET Lite vpeBubN */
	uint_t		eprpcnt;		/* ECHONET Lite vpeBubN */
} EOBJINIB;

/*
 *  ECHONET Lite m[hǗubN
 */
typedef struct echonet_object_control_block
{
	const EOBJINIB *profile;	/* ECHONET Lite m[hvt@Cւ̃|C^ */
	const EOBJINIB **eobjs;		/* ECHONET Lite IuWFNgXgւ̃|C^ */
	uint_t		eobjcnt;		/* ECHONET Lite IuWFNg */
} EOBJCB;

/*
 *  ECHONET Lite m[hIPAhX̑ΉubN̒`
 */
typedef struct echonet_node_address_block
{
	bool_t		inuse;			/* gp */
	uint8_t		ipaddr[16];		/* IPAhX */
} ENODADRB;

/*
 *  ECHONET Lite IuWFNgID̍őliechonet_cfg.cj
 */
extern const ID tmax_eobjid;

/*
 *  ECHONET Lite IuWFNgubÑGAiechonet_cfg.cj
 */
extern const EOBJINIB eobjinib_table[];

/*
 *  ECHONET Litem[hǗubN̐
 */
extern const int tnum_enodid;

/*
 *  ECHONET Lite IuWFNgǗubÑGAiechonet_cfg.cj
 */
extern EOBJCB eobjcb_table[];

/*
 * ECHONET Litem[hIPAhX̑Ή̐
 */
extern const int tnum_enodadr;

/*
 *  ECHONET Lite m[hIPAhX̑ΉubÑGAiechonet_cfg.cj
 */
extern ENODADRB enodadrb_table[];

/*
 * ECHONET Lite J[lIuWFNgID
 */
extern const ID ecn_svc_taskid;
extern const ID ecn_udp_taskid;
extern const ID ecn_api_mailboxid;
extern const ID ecn_svc_mailboxid;
extern const ID ecn_udp_mailboxid;
extern const ID ecn_svc_cychdrid;
extern const ID ecn_udp_cychdrid;

/*
 *  ECHONET Lite IuWFNgǗubNECHONET Lite IuWFNgIDo߂̃}N
 */
#define	EOBJID(p_eobjcb)	((ID)(((p_eobjcb) - eobjcb_table) + TMIN_EOBJID))

/*
 *  ECHONET Lite IuWFNg@\̏
 */
extern void initialize_echonet_object(void);

typedef EOBJINIB T_REOBJ;

typedef EPRPINIB T_RPRP;

typedef ENODADRB T_ENOD_ADDR;

/*
 * ECHONET LiteT[rXJn
 */
ER ecn_sta_svc();

/*
 * ECHONETIuWFNgQ
 */
ER ecn_ref_eobj(ID eobjid, T_REOBJ *pk_eobj);

/*
 * ECHONETvpeBQ
 */
ER ecn_ref_eprp(ID eobjid, uint8_t epc, T_RPRP *pk_eprp);

/*
 * vpeBlݗvisvjd쐬
 */
ER ecn_esv_seti(T_EDATA **ppk_esv, ID eobjid, uint8_t epc, uint8_t pdc, const void *p_edt);

/*
 * vpeBlݗvivjd쐬
 */
ER ecn_esv_setc(T_EDATA **ppk_esv, ID eobjid, uint8_t epc, uint8_t pdc, const void *p_edt);

/*
 * vpeBlǂݏovd쐬
 */
ER ecn_esv_get(T_EDATA **ppk_esv, ID eobjid, uint8_t epc);

/*
 * vpeBlʒmvd쐬
 */
ER ecn_esv_inf_req(T_EDATA **ppk_esv, ID eobjid, uint8_t epc);

/*
 * vpeBl݁Eǂݏovd쐬
 */
ER ecn_esv_set_get(T_EDATA **ppk_esv, ID eobjid, uint8_t epc, uint8_t pdc, const void *p_edt);

/*
 * vpeBl݁Eǂݏovd܂Ԃw
 */
ER ecn_trn_set_get(T_EDATA *pk_esv, int *p_trn_pos);

/*
 * vpeBl݁EǂݏovdIw
 */
ER ecn_end_set_get(T_EDATA *pk_esv, int trn_pos);

/*
 * vpeBlʒmivjd쐬
 */
ER ecn_esv_infc(T_EDATA **ppk_esv, ID eobjid, ID seobjid, uint8_t sepc);

/*
 * vdւ̃vpeBwǉ
 */
ER ecn_add_epc(T_EDATA *pk_esv, uint8_t epc);

/*
 * vdւ̃vpeBf[^ǉ
 */
ER ecn_add_edt(T_EDATA *pk_esv, uint8_t epc, uint8_t pdc, const void *p_edt);

/*
 * vd̑M
 */
ER ecn_snd_esv(T_EDATA *pk_esv);

/*
 * d̎M|[O
 */
ER ecn_prcv_esv(T_EDATA **ppk_esv);

/*
 * d̔j
 */
ER ecn_rel_esv(T_EDATA *pk_esv);

/*
 * d̑Mm[h擾
 */
ID ecn_get_enod(T_EDATA *pk_esv);

/*
 * d̑M@IuWFNg擾
 */
ID ecn_get_eobj(T_EDATA *pk_esv);

/*
 * d̓Ce[^[
 */
ER ecn_itr_ini(T_ENUM_EPC *pk_itr, T_EDATA *pk_esv);

/*
 * d̓Ce[^[CNg
 */
ER ecn_itr_nxt(T_ENUM_EPC *pk_itr, uint8_t *p_epc, uint8_t *p_pdc, void *p_edt);

/*
 * d҂̊荞ݑM
 */
ER ecn_brk_wai(const void *p_dat, int datsz);

/*
 * 荞݃f[^̎擾
 */
ER ecn_get_brk_dat(T_EDATA *pk_esv, void *p_buf, int bufsz, int *p_datsz);

/*
 * f[^ݒ֐
 */
int ecn_data_prop_set(const EPRPINIB *item, const void *src, int size, bool_t *anno);

/*
 * f[^擾֐
 */
int ecn_data_prop_get(const EPRPINIB *item, void *dst, int size);

#ifdef __cplusplus
}
#endif

#endif // ECHONET_H
