/*
 *  TOPPERS ECHONET Lite Communication Middleware
 * 
 *  Copyright (C) 2014 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: echonet_dbg.c 107 2015-06-10 11:40:31Z coas-nagasima $
 */

/*
 *		ECHONET Lite ^XN fobOo
 */

#include <kernel.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <t_syslog.h>
#include <sil.h>
#include <ctype.h>

#include "syssvc/serial.h"
#include "syssvc/syslog.h"

#include "echonet.h"
#include "echonet_dbg.h"
#include "echonet_fbs.h"
#include "echonet_task.h"

#ifdef ECN_DBG_WAI_ENA
#define _ECN_DBG_WAI_SYSLOG _ecn_dbg_wai_syslog()
#else
#define _ECN_DBG_WAI_SYSLOG
#endif

#if defined(ECN_DBG_PUT_ENA) || defined(ECN_CAP_PUT_ENA)
#if defined(ECN_DBG_WAI_ENA)
static ER _ecn_dbg_wai_syslog(void);
/*
 *  syslog()obt@ɗ]Tł܂ő҂
 */
static ER _ecn_dbg_wai_syslog(void)
{
	T_SYSLOG_RLOG	a_rlog;
	ER				a_ret;
	int				a_ct = 0;
#ifndef ECN_DBG_WAI_SYSLOG_RETRY
 #ifdef LOGTASK
  #define ECN_DBG_WAI_SYSLOG_RETRY 10
 #else
  #define ECN_DBG_WAI_SYSLOG_RETRY 0
 #endif
#endif

	for (;;) {
		a_ret = syslog_ref_log(&a_rlog);
		if (a_ret < 0)
			return a_ret;
		if (1 <= a_rlog.count) {
			a_ct = 0;
		} else
#if (defined ECN_DBG_WAI_SYSLOG_RETRY) && (0 < ECN_DBG_WAI_SYSLOG_RETRY)
		if (ECN_DBG_WAI_SYSLOG_RETRY <= ++a_ct)
#endif
		{
/*			a_ret = dly_tsk(100);
			if (a_ret < 0 && a_ret != E_RLWAI)
				return a_ret; // */
			break;
		}

		a_ret = dly_tsk(1);
		if (a_ret < 0 && a_ret != E_RLWAI)
			return a_ret;
	}
	return 0;
}
#endif /* #if defined(ECN_DBG_WAI_ENA) */

/*
 * fobOo
 * F		ECN_DBG_PUT "task start" ECN_DBG_END;
 */
int _ecn_dbg_dbgput(const char *fp_srcloc, const char *fp_form, ...)
{
	va_list v;
	char	*p_buf = 0;
	ID		tskid;
#ifdef ECN_DBG_PUT_USE_STATIC
 #ifndef SEM_ECN_DBG_PUT
	/* 256byteobt@8{[e[V */
	static char				a_buf[8][256];
	static volatile uint_t	a_buf_idx = 0;
	uint_t					a_buf_idx_a;
 #else
	/* Z}tHpāA1{̃obt@ɕׂĎg */
	static char				a_buf[1024];
	static volatile uint_t	a_buf_pos = 0;
	size_t					a_buf_len;
  #define ECN_DBG_PUT_BUF_MAX a_buf_len
 #endif /* #ifdef SEM_ECN_DBG_PUT */
#endif /* #ifdef ECN_DBG_PUT_USE_STATIC */
#ifndef ECN_DBG_PUT_BUF_MAX
 #define ECN_DBG_PUT_BUF_MAX 255
#endif

	get_tid(&tskid);

	if (!fp_srcloc)
		fp_srcloc = "(null)";

#ifdef SEM_ECN_DBG_PUT
	syscall(wai_sem(SEM_ECN_DBG_PUT));
#endif

#ifdef ECN_DBG_PUT_USE_STATIC
 #ifndef SEM_ECN_DBG_PUT
	a_buf_idx_a = ++a_buf_idx;
	p_buf = a_buf[a_buf_idx_a & 0x07];
 #else
	if (sizeof(a_buf) - a_buf_pos < 80)	/* c肪80byteɂȂA擪ɖ߂ */
		a_buf_pos = 0;
	p_buf = a_buf + a_buf_pos;
	a_buf_len = sizeof(a_buf) - a_buf_pos - 1;
	if (80 * 2 <= a_buf_len)	/* 80byte*2ȏ̗]邤́A80bytec */
		a_buf_len -= 80;
 #endif /* #ifdef SEM_ECN_DBG_PUT */
#else
	p_buf = (char *)_ecn_fbs_mbx_get(255);
	if (!p_buf) {
		syslog(LOG_NOTICE, "%s[%d]: (+mbx fault) %s", fp_srcloc, (int)tskid, fp_form);
 #ifdef SEM_ECN_DBG_PUT
		syscall(sig_sem(SEM_ECN_DBG_PUT));
 #endif /* #ifdef SEM_ECN_DBG_PUT */
		return 1;
	}
#endif /* #ifdef ECN_DBG_PUT_USE_STATIC */

	va_start(v, fp_form);

#ifdef _MSC_VER
	vsnprintf_s(p_buf, ECN_DBG_PUT_BUF_MAX, ECN_DBG_PUT_BUF_MAX, fp_form, v);
#else
	vsprintf(p_buf, fp_form, v);
#endif
#ifdef ECN_DBG_PUT_USE_STATIC
 #ifdef SEM_ECN_DBG_PUT
	a_buf_len = strlen(p_buf) + 1;
	/* c肪80byteɂȂ */
	if (sizeof(a_buf) - a_buf_pos - a_buf_len < 80) {
		/* 擪ɖ߂ */
		a_buf_pos = 0;
	} else {
		a_buf_pos += a_buf_len;
	}
 #endif /* #ifdef SEM_ECN_DBG_PUT */
#endif

	_ECN_DBG_WAI_SYSLOG; /* syslog()obt@ɗ]Tł܂ő҂ */

#ifdef SEM_ECN_DBG_PUT
	syscall(sig_sem(SEM_ECN_DBG_PUT));
#endif

	syslog(LOG_NOTICE, "%s[%d]: %s", fp_srcloc, (int)tskid, p_buf);

	va_end(v);

#ifndef ECN_DBG_PUT_USE_STATIC
	_ecn_fbs_mbx_rel(p_buf);
#endif
	return 0;
}

/* ECN_ENOD_ID̕ϊ */
const char *_ecn_dbg_enod2str(ECN_ENOD_ID fa_enod_id)
{
/*	#define _ECN_FBS_DBG_ENOD2STR_BUF_MAX_BIT (4)
/*	*/
#ifdef _ECN_FBS_DBG_ENOD2STR_BUF_MAX_BIT
	static volatile uint8_t a_idx_vol = 0;
	static char a_buf[1 << _ECN_FBS_DBG_ENOD2STR_BUF_MAX_BIT][sizeof("ENOD_REMOTE_ID()")+5];
	uint8_t a_idx;
#endif

	if (fa_enod_id == ENOD_NOT_MATCH_ID)
		return "ENOD_NOT_MATCH_ID";
	if (fa_enod_id == ENOD_MULTICAST_ID)
		return "ENOD_MULTICAST_ID";
	if (fa_enod_id == ENOD_LOCAL_ID)
		return "ENOD_LOCAL_ID";
	if (fa_enod_id == ENOD_API_ID)
		return "ENOD_API_ID";
	if (fa_enod_id == ENOD_REMOTE_ID)
		return "ENOD_REMOTE_ID(0)";
	if (fa_enod_id == ((ENOD_REMOTE_ID) + 1))
		return "ENOD_REMOTE_ID(1)";
	if (fa_enod_id == ((ENOD_REMOTE_ID) + 2))
		return "ENOD_REMOTE_ID(2)";
	if (fa_enod_id == ((ENOD_REMOTE_ID) + 3))
		return "ENOD_REMOTE_ID(3)";
	if (fa_enod_id == ((ENOD_REMOTE_ID) + 4))
		return "ENOD_REMOTE_ID(4)";
	if (fa_enod_id == ((ENOD_REMOTE_ID) + 5))
		return "ENOD_REMOTE_ID(5)";
#ifdef _ECN_FBS_DBG_ENOD2STR_BUF_MAX_BIT
	if (ENOD_REMOTE_ID <= fa_enod_id) {
		/* return "ENOD_REMOTE_ID"; */
		a_idx = (++a_idx_vol) & ((1 << _ECN_FBS_DBG_ENOD2STR_BUF_MAX_BIT) - 1);
#ifdef _MSC_VER
		sprintf_s(a_buf[a_idx], sizeof(*a_buf), "ENOD_REMOTE_ID(%d)", fa_enod_id - ENOD_REMOTE_ID);
#else
		sprintf(a_buf[a_idx], "ENOD_REMOTE_ID(%d)", fa_enod_id - ENOD_REMOTE_ID);
#endif
		return a_buf[a_idx];
	}
#endif

	return "?";
}

/*
 * oCi_vo
 */
void _ecn_dbg_bindmp(const uint8_t *buffer, size_t len)
{
	/* static̈̃obt@؂ւ(2^n) */
	#define _ECN_FBS_DBG_BINDMP_BUF_MAX_BIT (4)
/*	*/
#ifdef SEM_ECN_DBG_BINDMP
 #ifdef _ECN_FBS_DBG_BINDMP_BUF_MAX_BIT
  #undef _ECN_FBS_DBG_BINDMP_BUF_MAX_BIT
  /* Z}tH(SEM_ECN_DBG_BINDMP)`ĂꍇAobt@؂ւ͕svȂ̂undef */
 #endif
#endif
#ifndef _ECN_FBS_DBG_BINDMP_BUFLEN
 /* obt@TCY(bindmp1s܂TCY) */
 #define _ECN_FBS_DBG_BINDMP_BUFLEN (80)
#endif
#ifdef _ECN_FBS_DBG_BINDMP_BUF_MAX_BIT
	/* static̈̃obt@؂ւ邽߂̊Ǘpϐ */
	static volatile uint8_t a_idx_vol = 0;
	/* static̈̃obt@؂ւ̈ */
	static char a_buf_area[1 << _ECN_FBS_DBG_BINDMP_BUF_MAX_BIT][_ECN_FBS_DBG_BINDMP_BUFLEN];
	uint8_t a_idx;
	char *a_buf;
#else
	/* static̈̃obt@̈ */
	static char a_buf[_ECN_FBS_DBG_BINDMP_BUFLEN];
#endif
	const uint8_t *p = buffer;			/* ǂݎ|C^ */
	int i, a_blk, a_blk_max, a_pos = 0;
	const T_ECN_EDT_HDR *p_req_esv;
	const T_ECN_INTERNAL_MSG *p_im;

#ifdef SEM_ECN_DBG_BINDMP
	syscall(wai_sem(SEM_ECN_DBG_BINDMP));
#endif

	if (len != 256) {
		a_blk_max = 1;
	} else {
		a_blk_max = ((T_ECN_FST_BLK *)buffer)->hdr.wr.blk
						+ (((T_ECN_FST_BLK *)buffer)->hdr.wr.pos ? 1 : 0);
		if (!a_blk_max)
			a_blk_max = 1;
	}
	#ifndef ECN_DBG_BINDMP_MAXLEN
	 /* bindmpo͂̍őTCY */
	 #define ECN_DBG_BINDMP_MAXLEN 1600
	#endif
	if (ECN_DBG_BINDMP_MAXLEN < len) {
		len = ECN_DBG_BINDMP_MAXLEN;
	}

#ifdef _ECN_FBS_DBG_BINDMP_BUF_MAX_BIT
	a_idx = (++a_idx_vol) & ((1 << _ECN_FBS_DBG_BINDMP_BUF_MAX_BIT) - 1);
	a_buf = a_buf_area[a_idx];
	/* #define a_buf (a_buf_area[a_idx]) */
#endif

	for (a_blk = 0; p && a_blk < a_blk_max; p = ((T_ECN_FST_BLK *)buffer)->lnk.p_sub[a_blk++]->dat) {
		if (0 < a_blk) {
			_ECN_DBG_WAI_SYSLOG; /* syslog()obt@ɗ]Tł܂ő҂ */
			syslog(LOG_NOTICE, "p_sub[%d] (0x%08X)", a_blk - 1, p);
		}
		memset(a_buf, 0, _ECN_FBS_DBG_BINDMP_BUFLEN);
		for (i = 0; i < (int)len; i++) {
			if (i % 16 == 0) {
				if (a_buf[0]) {
					_ECN_DBG_WAI_SYSLOG; /* syslog()obt@ɗ]Tł܂ő҂ */
					syslog(LOG_NOTICE, "%s", a_buf);
				}
#ifdef _MSC_VER
				sprintf_s(a_buf, _ECN_FBS_DBG_BINDMP_BUFLEN, "[%08X]:", i);
#else
				sprintf(a_buf, "[%08X]:", i);
#endif
				a_pos = strlen(a_buf);
			} else {
				a_buf[a_pos++] = (i % 16 == 8 ? '-':' ');
			}
#ifdef _MSC_VER
			sprintf_s(a_buf + a_pos, _ECN_FBS_DBG_BINDMP_BUFLEN - a_pos, "%02X", p[i]);
#else
			sprintf(a_buf + a_pos, "%02X", p[i]);
#endif
			a_pos += 2;
		}
		if (a_buf[0]) {
			_ECN_DBG_WAI_SYSLOG; /* syslog()obt@ɗ]Tł܂ő҂ */
			syslog(LOG_NOTICE, "%s", a_buf);
		}
		if (a_blk_max == 1)
			break;
	}

	if (len == 256) {
		switch (((const T_ECN_FST_BLK *)buffer)->hdr.type) {
		case ECN_MSG_ECHONET:
			p_req_esv = &((const T_ECN_FST_BLK *)buffer)->d.t_esv;
			_ECN_DBG_WAI_SYSLOG; /* syslog()obt@ɗ]Tł܂ő҂ */
			syslog(LOG_NOTICE, " sender: %d %s, target: %d %s",
				((T_ECN_FST_BLK *)buffer)->hdr.sender, _ecn_dbg_enod2str(((T_ECN_FST_BLK *)buffer)->hdr.sender),
				((T_ECN_FST_BLK *)buffer)->hdr.target, _ecn_dbg_enod2str(((T_ECN_FST_BLK *)buffer)->hdr.target));
			_ECN_DBG_WAI_SYSLOG; /* syslog()obt@ɗ]Tł܂ő҂ */
			syslog(LOG_NOTICE, " ecn_hdr: 0x%02X 0x%02X 0x%04X", p_req_esv->ecn_hdr.ehd1, p_req_esv->ecn_hdr.ehd2, p_req_esv->ecn_hdr.tid);
			_ECN_DBG_WAI_SYSLOG; /* syslog()obt@ɗ]Tł܂ő҂ */
			syslog(LOG_NOTICE, " edata: 0x%06X 0x%06X 0x%02X 0x%02X (%s)",
				p_req_esv->edata.seoj.eojx1 << 16 | p_req_esv->edata.seoj.eojx2 << 8 | p_req_esv->edata.seoj.eojx3,
				p_req_esv->edata.deoj.eojx1 << 16 | p_req_esv->edata.deoj.eojx2 << 8 | p_req_esv->edata.deoj.eojx3,
				p_req_esv->edata.esv, p_req_esv->edata.opc, _ecn_dbg_esv2str(p_req_esv->edata.esv));
			_ECN_DBG_WAI_SYSLOG; /* syslog()obt@ɗ]Tł܂ő҂ */
			syslog(LOG_NOTICE, " ecn_prp: 0x%02X 0x%02X", p_req_esv->ecn_prp.epc, p_req_esv->ecn_prp.pdc);
			_ECN_DBG_WAI_SYSLOG; /* syslog()obt@ɗ]Tł܂ő҂ */
			syslog(LOG_NOTICE, " cur(blk/pos): wr %d/%d, rd %d/%d",
				(int)((T_ECN_FST_BLK *)buffer)->hdr.wr.blk,
				(int)((T_ECN_FST_BLK *)buffer)->hdr.wr.pos,
				(int)((T_ECN_FST_BLK *)buffer)->hdr.rd.blk,
				(int)((T_ECN_FST_BLK *)buffer)->hdr.rd.pos);
		break;
		case ECN_MSG_INTERNAL:
			p_im = (const T_ECN_INTERNAL_MSG *)&((const T_ECN_FST_BLK *)buffer)->payload[0];
			syslog(LOG_NOTICE, " a_im.command: %d:%s", p_im->command,
				(p_im->command == ECN_INM_NOTIFY_INSTANCELIST ? "ECN_INM_NOTIFY_INSTANCELIST":
				(p_im->command == ECN_INM_RELEASE_WAIT ? "ECN_INM_RELEASE_WAIT" : "?")));
			memset(a_buf, 0, _ECN_FBS_DBG_BINDMP_BUFLEN);
			a_blk_max = ((const T_ECN_FST_BLK *)buffer)->hdr.wr.blk * 64
					+ ((const T_ECN_FST_BLK *)buffer)->hdr.wr.pos;
			if (0 < a_blk_max) {
				if (64 < a_blk_max)
					a_blk_max = 64;
				if (_ECN_FBS_DBG_BINDMP_BUFLEN < a_blk_max)
					a_blk_max = _ECN_FBS_DBG_BINDMP_BUFLEN;
				for (i = offsetof(T_ECN_INTERNAL_MSG, data); i < a_blk_max; i++) {
					a_blk = ((const T_ECN_FST_BLK *)buffer)->payload[i];
					if (!isprint(a_blk) || !isascii(a_blk))
						a_blk = '.';
					a_buf[i - 1] = a_blk;
				}
				syslog(LOG_NOTICE, " a_im.data: [%s]", &a_buf[offsetof(T_ECN_INTERNAL_MSG, data) - 1]);
			}
			break;
		default:
			syslog(LOG_NOTICE, " invalid type: %d", ((const T_ECN_FST_BLK *)buffer)->hdr.type);
		}
	}
	else if (8 <= len
	&& ((const T_ECN_FST_BLK *)buffer)->bin[0] == 0x10
	&& ((const T_ECN_FST_BLK *)buffer)->bin[1] == 0x81) {
		p_req_esv = (const T_ECN_EDT_HDR *)&((const T_ECN_FST_BLK *)buffer)->bin[0];
		_ECN_DBG_WAI_SYSLOG; /* syslog()obt@ɗ]Tł܂ő҂ */
		syslog(LOG_NOTICE, " ecn_hdr: 0x%02X 0x%02X 0x%04X", p_req_esv->ecn_hdr.ehd1, p_req_esv->ecn_hdr.ehd2, p_req_esv->ecn_hdr.tid);
		_ECN_DBG_WAI_SYSLOG; /* syslog()obt@ɗ]Tł܂ő҂ */
		syslog(LOG_NOTICE, " edata: 0x%06X 0x%06X 0x%02X 0x%02X (%s)",
			p_req_esv->edata.seoj.eojx1 << 16 | p_req_esv->edata.seoj.eojx2 << 8 | p_req_esv->edata.seoj.eojx3,
			p_req_esv->edata.deoj.eojx1 << 16 | p_req_esv->edata.deoj.eojx2 << 8 | p_req_esv->edata.deoj.eojx3,
			p_req_esv->edata.esv, p_req_esv->edata.opc, _ecn_dbg_esv2str(p_req_esv->edata.esv));
		_ECN_DBG_WAI_SYSLOG; /* syslog()obt@ɗ]Tł܂ő҂ */
		syslog(LOG_NOTICE, " ecn_prp: 0x%02X 0x%02X", p_req_esv->ecn_prp.epc, p_req_esv->ecn_prp.pdc);
	}
#ifdef SEM_ECN_DBG_BINDMP
	syscall(sig_sem(SEM_ECN_DBG_BINDMP));
#endif
}

/*
 * ECHONET LiteT[rXR[hϊ
 */
const char *_ecn_dbg_esv2str(uint8_t fa_esv)
{
	switch (fa_esv) {
	case ESV_SET_I_SNA:		return "vpeBlݗvs";			/* 0x50 */
	case ESV_SET_C_SNA:		return "vpeBlݗvs";			/* 0x51	*/
	case ESV_GET_SNA:		return "vpeBlǂݏos";				/* 0x52	*/
	case ESV_INF_SNA:		return "vpeBlʒms";					/* 0x53 */
	case ESV_SET_GET_SNA:	return "vpeBl݁Eǂݏos";	/* 0x5E	*/
	case ESV_SET_I:			return "vpeBlݗvisvj";		/* 0x60 */
	case ESV_SET_C:			return "vpeBlݗvivj";		/* 0x61 */
	case ESV_GET:			return "vpeBlǂݏov";					/* 0x62 */
	case ESV_INF_REQ:		return "vpeBlʒmv";						/* 0x63 */
	case ESV_SET_GET:		return "vpeBl݁Eǂݏov";		/* 0x6E */
	case ESV_SET_RES:		return "vpeBl݉";					/* 0x71 */
	case ESV_GET_RES:		return "vpeBlǂݏo";					/* 0x72 */
	case ESV_INF:			return "vpeBlʒm";							/* 0x73 */
	case ESV_INFC:			return "vpeBlʒmivj";				/* 0x74 */
	case ESV_SET_GET_RES:	return "vpeBl݁Eǂݏo";		/* 0x7E */
	case ESV_INFC_RES:		return "vpeBlʒm";						/* 0x7A */
	default:
		return "(unknown)";
	}
}
#endif /* #if defined(ECN_DBG_PUT_ENA) || defined(ECN_CAP_PUT_ENA) */
