/*
 *  TOPPERS ECHONET Lite Communication Middleware
 *
 *  Copyright (C) 2015 Cores Co., Ltd. Japan
 *
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 *
 *  @(#) $Id: wamp_router.c 107 2015-06-10 11:40:31Z coas-nagasima $
 */

#include <string.h>
#include "wamp.h"
#include "wamp_router.h"
#include "main.h"
#include "fbs_string.h"
#include "kernel_cfg.h"

#ifndef _MSC_VER
#ifndef strncpy_s
#define strncpy_s(dst, dsz, src, sz) strncpy(dst, src, sz)
#endif
#endif

wamp_session_t *wamp_router_hello(wamp_router_t *router)
{
	wamp_session_t *result = NULL, *pos, *end = &router->sessions[sizeof(router->sessions) / sizeof(router->sessions[0])];

	for(pos = router->sessions; pos < end; pos++) {
		if(pos->router != NULL)
			continue;
		
		result = pos;
		result->router = router;
		router->current_session = result;
	}

	return result;
}

void wamp_router_hello_realm(wamp_router_t *router, const char *value)
{
	wamp_session_t *s = router->current_session;
	strncpy_s(s->realm, sizeof(s->realm), value, sizeof(s->realm));
}

void wamp_router_hello_details_param(wamp_router_t *router, jsonsl_action_t action,
	struct jsonsl_state_st *state, const char *buf)
{
	static const char roles[] = "roles";
	static const char publisher[] = "publisher";
	static const char subscriber[] = "subscriber";
	static const char caller[] = "caller";
	static const char callee[] = "callee";
	wamp_session_t *s = router->current_session;

	switch (state->level) {
	case 3:
		switch (action){
		case JSONSL_ACTION_POP:
			switch (state->type)
			{
			case JSONSL_T_HKEY:
				if(strncmp(roles, router->s->jsn_buf, sizeof(roles) - 1) == 0){
					s->roles |= WAMP_ROUTER_ROLES_IN_GETTING;
				}
				break;
			default:
				break;
			}
			break;
		}
		break;
	case 4:
		switch (action){
		case JSONSL_ACTION_POP:
			switch (state->type)
			{
			case JSONSL_T_HKEY:
				if((s->roles & WAMP_ROUTER_ROLES_IN_GETTING) !=0 ){
					if(strncmp(publisher, router->s->jsn_buf, sizeof(publisher) - 1) == 0){
						s->roles |= WAMP_ROUTER_ROLES_PUBLISHER;
					}
					else if(strncmp(subscriber, router->s->jsn_buf, sizeof(subscriber) - 1) == 0){
						s->roles |= WAMP_ROUTER_ROLES_SUBSCRIBER;
					}
					else if(strncmp(caller, router->s->jsn_buf, sizeof(caller) - 1) == 0){
						s->roles |= WAMP_ROUTER_ROLES_CALLER;
					}
					else if(strncmp(callee, router->s->jsn_buf, sizeof(callee) - 1) == 0){
						s->roles |= WAMP_ROUTER_ROLES_CALLEE;
					}
				}
				break;
			default:
				break;
			}
			break;
		}
		break;
	}
}

void wamp_router_hello_details(wamp_router_t *router)
{
	wamp_session_t *s = router->current_session;
	s->roles &= ~WAMP_ROUTER_ROLES_IN_GETTING;
}

void wamp_router_hello_close(struct wamp_state *s)
{
	wamp_router_t *router = &s->router;
	wamp_session_t *session = router->current_session;
	ECN_FBS_ID buf;
	ECN_FBS_SSIZE_T pos = 0, start;
	ER ret;

	router->session_id++;
	if(router->session_id == 0){
		router->session_id++;
	}
	session->id = router->session_id;

	// send WELLCOM or ABORT
	_ecn_fbs_cre(16, &buf);

	ret = fbs_printf(buf, &pos, "[2,%d,{\"roles\":{", session->id);
	if (ret != E_OK) {
		syslog(LOG_WARNING, "fbs_printf() result = %d", ret);
		_ecn_fbs_del(buf);
		return;
	}

	start = pos;
	if(session->roles & WAMP_ROUTER_ROLES_PUBLISHER){
		ret = fbs_printf(buf, &pos, "\"publisher\":{},");
		if (ret != E_OK) {
			syslog(LOG_WARNING, "fbs_printf() result = %d", ret);
			_ecn_fbs_del(buf);
			return;
		}
	}
	if(session->roles & WAMP_ROUTER_ROLES_SUBSCRIBER){
		ret = fbs_printf(buf, &pos, "\"subscriber\":{},");
		if (ret != E_OK) {
			syslog(LOG_WARNING, "fbs_printf() result = %d", ret);
			_ecn_fbs_del(buf);
			return;
		}
	}
	if(session->roles & WAMP_ROUTER_ROLES_CALLER){
		ret = fbs_printf(buf, &pos, "\"caller\":{},");
		if (ret != E_OK) {
			syslog(LOG_WARNING, "fbs_printf() result = %d", ret);
			_ecn_fbs_del(buf);
			return;
		}
	}
	if(session->roles & WAMP_ROUTER_ROLES_CALLEE){
		ret = fbs_printf(buf, &pos, "\"callee\":{},");
		if (ret != E_OK) {
			syslog(LOG_WARNING, "fbs_printf() result = %d", ret);
			_ecn_fbs_del(buf);
			return;
		}
	}

	/* Ō"," */
	if(start != pos)
		pos--;

	ret = fbs_printf(buf, &pos, "}}]");
	if (ret != E_OK) {
		syslog(LOG_WARNING, "fbs_printf() result = %d", ret);
		_ecn_fbs_del(buf);
		return;
	}

	ret = main_send_message(buf, s->wbsid);
	if (ret != E_OK) {
		syslog(LOG_WARNING, "wamp_router_hello_close() : main_send_message() result = %d", ret);
	}
}

void wamp_router_authenticate(wamp_router_t *router)
{
}

void wamp_router_authenticate_signature(wamp_router_t *router, const char *value)
{
}

void wamp_router_authenticate_extra(wamp_router_t *router, const char *value)
{
}

void wamp_router_authenticate_extra_param(wamp_router_t *router, jsonsl_action_t action,
	struct jsonsl_state_st *state, const char *buf)
{
}

void wamp_router_authenticate_close(struct wamp_state *s)
{
}

void wamp_router_goodbye(wamp_router_t *router)
{
}

void wamp_router_goodbye_details_param(wamp_router_t *router, jsonsl_action_t action,
	struct jsonsl_state_st *state, const char *buf)
{
}

void wamp_router_goodbye_details(wamp_router_t *router)
{
}

void wamp_router_goodbye_reason(wamp_router_t *router, const char *value)
{
}

void wamp_router_goodbye_close(struct wamp_state *s)
{
	wamp_router_t *router = &s->router;
	wamp_session_t *session = router->current_session;
	ECN_FBS_ID buf;
	ECN_FBS_SSIZE_T pos = 0;
	ER ret;

	if(session == NULL)
		return;

	// send GOODBYE
	ret = _ecn_fbs_cre(1, &buf);
	if (ret != E_OK) {
		syslog(LOG_WARNING, "_ecn_fbs_cre() result = %d", ret);
		return;
	}

	ret = fbs_printf(buf, &pos, "[6,{},\"wamp.error.goodbye_and_out\"]");
	if (ret != E_OK) {
		syslog(LOG_WARNING, "fbs_printf() result = %d", ret);
		_ecn_fbs_del(buf);
		return;
	}

	ret = main_send_message(buf, s->wbsid);
	if (ret != E_OK) {
		syslog(LOG_WARNING, "wamp_router_goodbye_close() : main_send_message() result = %d", ret);
	}

	memset(session, 0, sizeof(session));
}
