/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2014 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: ether_phy.h 107 2015-06-10 11:40:31Z coas-nagasima $
 */

#ifndef ETHER_PHY
#define ETHER_PHY

#include "if_rx62nreg.h"

typedef enum _phy_mode_t{
	PHY_MODE_10BASE_HALF	= 0x00,
	PHY_MODE_10BASE_FULL	= 0x01,
	PHY_MODE_100BASE_HALF	= 0x02,
	PHY_MODE_100BASE_FULL	= 0x03,
} PHY_MODE_T;

typedef enum _phy_state_t{
	PHY_STATE_UNINIT,
	PHY_STATE_RESETING,
	PHY_STATE_RESET,
	PHY_STATE_LINKED,
	PHY_STATE_NEGOTIATED,
} PHY_STATE_T;

extern PHY_STATE_T phy_reset(PHY_STATE_T state, uint8_t phy_addr);
extern PHY_STATE_T phy_initialize(PHY_STATE_T state, uint8_t phy_addr, PHY_MODE_T *mode);
extern bool_t phy_is_link(uint8_t phy_addr);
extern uint16_t phy_read_reg(uint8_t phy_addr, uint8_t rReg);
extern void phy_write_reg(uint8_t phy_addr, uint8_t wReg, uint16_t wdata);

#endif
